Attribute VB_Name = "GDIPrinting"
Option Explicit

Type TPrtJob
  a As Single
  x As Single
  y As Single
  s As String
End Type
Type TLineJob
  x1 As Single
  x2 As Single
  y1 As Single
  y2 As String
  col As Long
  w As Long
End Type
Type TEllipseJob
  x As Single
  y As Single
  rx As Single
  ry As String
  w As Long
End Type
Type TRectJob
  x1 As Single
  x2 As Single
  y1 As Single
  y2 As String
  w As Long
End Type
Type RECTS
  Left As Integer
  Top As Integer
  Right As Integer
  Bottom As Integer
  w As Long
End Type
Type MetaFileHeader     ' 22 bytes
  Key As Long
  hMF As Integer
  bbox As RECTS
  inch As Integer
  reserved As Long
  checksum As Integer
End Type

Type SIZE
  cx As Long
  cy As Long
End Type
Type TRECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Type POINTAPI
        x As Long
        y As Long
End Type

'Clipboard
Declare Function SetClipboardData Lib "user32" (ByVal wFormat As Long, ByVal hMem As Long) As Long
Declare Function OpenClipboard Lib "user32" (ByVal hwnd As Long) As Long
Declare Function CloseClipboard Lib "user32" () As Long
Declare Function EmptyClipboard Lib "user32" () As Long
Public Const CF_ENHMETAFILE = 14

'API fr Grafik
Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal h As Long, ByVal w As Long, ByVal E As Long, ByVal O As Long, ByVal w As Long, ByVal i As Long, ByVal u As Long, ByVal s As Long, ByVal c As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal f As String) As Long
Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Global Const PS_DASH = 1
Global Const PS_DOT = 2
Global Const PS_DASHDOT = 3
Global Const PS_DASHDOTDOT = 4
Global Const PS_ALTERNATE = 8
Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function SetMapMode Lib "gdi32" (ByVal hDC As Long, ByVal nMapMode As Long) As Long
Public Const MM_ANISOTROPIC = 8
Public Const MM_ISOTROPIC = 7
Declare Function SetWindowOrgEx Lib "gdi32" (ByVal hDC As Long, ByVal nx As Long, ByVal ny As Long, lpPoint As POINTAPI) As Long
Declare Function GetWindowOrgEx Lib "gdi32" (ByVal hDC As Long, lpPoint As POINTAPI) As Long
Declare Function SetViewportOrgEx Lib "gdi32" (ByVal hDC As Long, ByVal nx As Long, ByVal ny As Long, lpPoint As POINTAPI) As Long
Declare Function SetWindowExtEx Lib "gdi32" (ByVal hDC As Long, ByVal nx As Long, ByVal ny As Long, lpSize As SIZE) As Long
Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Declare Function Ellipse Lib "gdi32" (ByVal hDC As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, lpPoint As POINTAPI) As Long
Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
Declare Function Polygon Lib "gdi32" (ByVal hDC As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Public Const BLACK_BRUSH = 4
Declare Function CreateRectRgn Lib "gdi32" (ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
'Declare Function SelectClipRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long) As Long
'Declare Function SetRectRgn Lib "gdi32" (ByVal hRgn As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Declare Function CreateEllipticRgn Lib "gdi32" (ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Global Const DRIVERVERSION = 0
Global Const TECHNOLOGY = 2
Global Const HORZSIZE = 4
Global Const VERTSIZE = 6
Global Const HORZRES = 8
Global Const VERTRES = 10
Global Const BITSPIXEL = 12
Global Const PLANES = 14
Global Const NUMBRUSHES = 16
Global Const NUMPENS = 18
Global Const NUMMARKERS = 20
Global Const NUMFONTS = 22
Global Const NUMCOLORS = 24
Global Const PDEVICESIZE = 26
Global Const CURVECAPS = 28
Global Const LINECAPS = 30
Global Const POLYGONALCAPS = 32
Global Const TEXTCAPS = 34
Global Const CLIPCAPS = 36
Global Const RASTERCAPS = 38
Global Const ASPECTX = 40
Global Const ASPECTY = 42
Global Const ASPECTXY = 44
Global Const LOGPIXELSX = 88
Global Const LOGPIXELSY = 90
Global Const SIZEPALETTE = 104
Global Const NUMRESERVED = 106
Global Const COLORRES = 108
Global Const PHYSICALWIDTH = 110
Global Const PHYSICALHEIGHT = 111
Global Const PHYSICALOFFSETX = 112
Global Const PHYSICALOFFSETY = 113
Declare Function GetTextExtentPoint32 Lib "gdi32" Alias "GetTextExtentPoint32A" (ByVal hDC As Long, ByVal lpsz As String, ByVal cbString As Long, lpSize As SIZE) As Long


'Windows Metafile
Declare Function CreateMetaFile Lib "gdi32" Alias "CreateMetaFileA" (ByVal lpString As String) As Long
Declare Function CloseMetaFile Lib "gdi32" (ByVal hMF As Long) As Long
Declare Function PlayMetaFile Lib "gdi32" (ByVal hDC As Long, ByVal hMF As Long) As Long
Declare Function DeleteMetaFile Lib "gdi32" (ByVal hMF As Long) As Long
'Declare Function CopyMetaFile Lib "gdi32" Alias "CopyMetaFileA" (ByVal hMF As Long, ByVal lpFileName As String) As Long
Declare Function GetMetaFileBitsEx Lib "gdi32" (ByVal hMF As Long, ByVal nSize As Long, lpvData As Any) As Long

'Enhanced Metafile
Declare Function CreateEnhMetaFile Lib "gdi32" Alias "CreateEnhMetaFileA" (ByVal hdcRef As Any, ByVal lpFileName As String, lpRect As TRECT, ByVal lpDescription As String) As Long
Declare Function PlayEnhMetaFile Lib "gdi32" (ByVal hDC As Long, ByVal hemf As Long, lpRect As TRECT) As Long
Declare Function CloseEnhMetaFile Lib "gdi32" (ByVal hDC As Long) As Long
Declare Function DeleteEnhMetaFile Lib "gdi32" (ByVal hemf As Long) As Long
'Declare Function CopyEnhMetaFile Lib "gdi32" Alias "CopyEnhMetaFileA" (ByVal hemfSrc As Long, ByVal lpszFile As String) As Long
'Declare Function GetEnhMetaFileHeader Lib "gdi32" (ByVal hemf As Long, ByVal cbBuffer As Long, lpemh As ENHMETAHEADER) As Long
'Declare Function GetEnhMetaFileBits Lib "gdi32" (ByVal hemf As Long, ByVal cbBuffer As Long, lpbBuffer As Byte) As Long

'Devicecontext
'Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function SaveDC Lib "gdi32" (ByVal hDC As Long) As Long
Declare Function RestoreDC Lib "gdi32" (ByVal hDC As Long, ByVal nSavedDC As Long) As Long
'Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long

'Speicher
Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Public Const GMEM_MOVEABLE = &H2
Public Const GMEM_ZEROINIT = &H40
Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long

'Dateien
Declare Function lcreat Lib "kernel32" Alias "_lcreat" (ByVal lpPathName As String, ByVal iAttribute As Long) As Long
Declare Function lclose Lib "kernel32" Alias "_lclose" (ByVal hFile As Long) As Long
Declare Function lopen Lib "kernel32" Alias "_lopen" (ByVal lpPathName As String, ByVal iReadWrite As Long) As Long
Declare Function lread Lib "kernel32" Alias "_lread" (ByVal hFile As Long, lpBuffer As Any, ByVal wBytes As Long) As Long
Declare Function lwrite Lib "kernel32" Alias "_lwrite" (ByVal hFile As Long, lpBuffer As Any, ByVal wBytes As Long) As Long
Declare Function hwrite Lib "kernel32" Alias "_hwrite" (ByVal hFile As Long, lpBuffer As Any, ByVal lBytes As Long) As Long
Public Const OF_READ = &H0
Public Const OF_READWRITE = &H2
Public Const OF_WRITE = &H1
Public Const OF_SHARE_COMPAT = &H0
Public Const OF_SHARE_DENY_NONE = &H40
Public Const OF_SHARE_DENY_READ = &H30
Public Const OF_SHARE_DENY_WRITE = &H20
Public Const OF_SHARE_EXCLUSIVE = &H10
Declare Function DeleteFile Lib "kernel32" Alias "DeleteFileA" (ByVal lpFileName As String) As Long

Type DOCINFO
  cbSize As Long
  lpszDocName As String
  lpszOutput As String
End Type
Declare Function EndDoc Lib "gdi32" (ByVal hDC As Long) As Long
Declare Function StartDoc Lib "gdi32" Alias "StartDocA" (ByVal hDC As Long, lpdi As DOCINFO) As Long
Declare Function StartPage Lib "gdi32" (ByVal hDC As Long) As Long
Declare Function EndPage Lib "gdi32" (ByVal hDC As Long) As Long


Type PRINTER_DEFAULTS_AS_String
        pDatatype As String
        pDevMode As Long
        DesiredAccess As Long
End Type
Type PRINTER_INFO_1
        flags As Long
        pDescription As Long
        pName As Long
        pComment As Long
End Type
Type PRINTER_INFO_2
        pServerName As Long
        pPrinterName As Long
        pShareName As Long
        pPortName As Long
        pDriverName As Long
        pComment As Long
        pLocation As Long
        pDevMode As Long  ' Pointer to DEVMODE
        pSepFile As Long
        pPrintProcessor As Long
        pDatatype As Long
        pParameters As Long
        pSecurityDescriptor As Long ' Pointer to SECURITY_DESCRIPTOR
        Attributes As Long
        Priority As Long
        DefaultPriority As Long
        StartTime As Long
        UntilTime As Long
        Status As Long
        cJobs As Long
        AveragePPM As Long
End Type
Type PRINTER_INFO_3
        pSecurityDescriptor As Long ' Pointer to SECURITY_DESCRIPTOR
End Type
Type PRINTER_INFO_4
  pPrinterName As Long
  pServerName As Long
  Attributes As Long
End Type
Type PRINTER_INFO_5
        pPrinterName As Long
        pPortName As Long
        Attributes As Long
        DeviceNotSelectedTimeout As Long
        TransmissionRetryTimeout As Long
End Type
Declare Function OpenPrinterStr Lib "winspool.drv" Alias "OpenPrinterA" (ByVal pPrinterName As String, phPrinter As Long, pDefault As PRINTER_DEFAULTS_AS_String) As Long
'Declare Function ClosePrinter Lib "winspool.drv" (ByVal hPrinter As Long) As Long
Declare Function PrinterProperties Lib "winspool.drv" (ByVal hwnd As Long, ByVal hPrinter As Long) As Long

Declare Function CreateDCBynum Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName As String, ByVal lpDeviceName As String, ByVal lpOutput As String, ByVal lpInitData As Long) As Long

'c=zielcontrol
'x,y=position in twips
'a=winkel in grad
's=string
'ToDo=optionaler Parameter: 1 =jetzt wirklich mahlen
Sub GdiPrint(dc As Long, ByVal x As Long, ByVal y As Long, ByVal a As Long, ByVal s As String, Optional ToDo)
  
  Static PrtJob(1 To 9999) As TPrtJob
  Static n As Long
  Dim l As Long
  
  Dim fontOld As Long
  Dim str As String
  
  If IsMissing(ToDo) Then
    ToDo = 0
  End If
  
  If ToDo = 1 Then
    
  
    
    For l = 1 To n
      Call TextOut(dc, PrtJob(l).x, PrtJob(l).y, PrtJob(l).s, Len(PrtJob(l).s))
    Next l
    n = 0
  ElseIf ToDo = 2 Then
    n = 0
  Else
    If s <> "" Then
      n = n + 1
      PrtJob(n).a = a
      PrtJob(n).s = s
      PrtJob(n).x = x
      PrtJob(n).y = y
    End If
  End If
  
End Sub


''c=zielcontrol
''x1,y1=links oben position in twips
''x2,y2=recht unten position in twips
''ToDo=optionaler Parameter: 1 =jetzt wirklich mahlen
'Private Sub kpRect(c As Control, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long, Optional ByVal ToDo)
'Dim OldSub As String
'OldSub = AktSub
'AktSub = "kp_grafik, kpRect"
'#If deb = 1 Then
'  On Error GoTo 0
'#Else
'  On Error GoTo lblError
'#End If
'
'  Static RectJob(1 To 9999) As TRectJob
'  Static n As Long
'  Dim l As Long
'
'  Dim dc As Long
'  Dim str As String
'  Dim brushBlack As Long, brushOld As Long
'  Dim halfWidth As Long
'  Dim tpp As Single
'  Dim Job As Long
'
'  If IsMissing(ToDo) Then
'    ToDo = 0
'  End If
'
'  If ToDo = 1 Then
'    dc = lngTmpMetaDC
'    brushBlack = GetStockObject(BLACK_BRUSH)
'    brushOld = SelectObject(dc, brushBlack)
'    For l = 1 To n
'      Call dcRect(c, RectJob(l).x1, RectJob(l).y1, RectJob(l).x2, RectJob(l).y2)
'    Next l
'    Call SelectObject(dc, brushOld)
'    Call DeleteObject(brushBlack)
'    n = 0
'  ElseIf ToDo = 2 Then
'    n = 0
'  Else
'    If x1 > x2 Then
'      Call Swap(x1, x2)
'    End If
'
'    If y1 > y2 Then
'      Call Swap(y1, y2)
'    End If
'
'    If y1 < lngYmin And y2 >= lngYmin Then
'      y1 = lngYmin
'    End If
'    If y2 > lngYmax And y1 <= lngYmax Then
'      y2 = lngYmax
'    End If
'    If y1 >= lngYmin And y1 <= lngYmax And y2 >= lngYmin And y2 <= lngYmax Then
'      n = n + 1
'      RectJob(n).x1 = CLng(x1)
'      RectJob(n).y1 = CLng(y1)
'      RectJob(n).x2 = CLng(x2)
'      RectJob(n).y2 = CLng(y2)
'    End If
'  End If
'
'
'AktSub = OldSub
'Exit Sub
'
'lblError:
'  errorbox (Err)
'  Call MausDefault
'  AktSub = OldSub
'
'End Sub
'


'c=zielcontrol
'x1,y1=start-position in twips
'x2,y2=ziel-position in twips
'col=farbe
'ToDo=optionaler Parameter: 1 =jetzt wirklich mahlen
Sub gdiLine(Hnd As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long, ByVal w As Long, ByVal col As Long, Optional ToDo)

  Static n As Long
  Dim l As Long, i As Single
  Dim width As Long
  Static LineJob(1 To 9999) As TLineJob
  Dim penColor As Long
  Dim pen As Long
  Dim penOld As Long
  Dim oldPos As POINTAPI
  Dim dc As Long
  Dim lastW As Long, lastCol As Long
  
  If Not IsMissing(ToDo) Then
    If ToDo = 1 Then
    
      dc = Hnd
  
      For l = 1 To n
        If LineJob(l).col <> lastCol Or LineJob(l).w <> lastW Then
          If pen > 0 Then
            Call DeleteObject(pen)
          End If
          pen = CreatePen(0, LineJob(l).w, LineJob(l).col)
          Call SelectObject(dc, pen)
          
          lastCol = LineJob(l).col
          lastW = LineJob(l).w
        End If
        
        x1 = LineJob(l).x1
        x2 = LineJob(l).x2
        y1 = LineJob(l).y1
        y2 = LineJob(l).y2
        
        Call MoveToEx(dc, x1, y1, oldPos)
        Call LineTo(dc, x2, y2)

      Next l
      
      Call DeleteObject(pen)
      n = 0
    End If
  ElseIf Not IsMissing(ToDo) Then
    If ToDo = 2 Then
      n = 0
    End If
  Else  'zur Liste hinzufgen
    'erstmal dafr sorgen, das y1 < y2 ist,
    'das vereinfacht die folgenden Untersuchungen
    If y1 > y2 Then
      Call Swap(x1, x2): Call Swap(y1, y2)
    End If
    
    n = n + 1
    LineJob(n).x1 = CLng(x1)
    LineJob(n).y1 = CLng(y1)
    LineJob(n).x2 = CLng(x2)
    LineJob(n).y2 = CLng(y2)
    LineJob(n).col = col
    LineJob(n).w = w
  End If
 
End Sub

'tauscht den Inhalt von V1 und V2
'(us)
Sub Swap(ByRef v1 As Variant, ByRef v2 As Variant)

Dim vTmp As Variant

vTmp = v1
v1 = v2
v2 = vTmp

End Sub



''c=zielcontrol
''x,y=mittelpunkt-position in twips
''rx,ry=radien
''ToDo=optionaler Parameter: 1 =jetzt wirklich mahlen
'Private Sub kpEllipse(c As Control, ByVal x As Long, ByVal y As Long, ByVal rx As Long, ByVal ry As Long, Optional s)
'Dim OldSub As String
'OldSub = AktSub
'AktSub = "kp_grafik, kpEllipse"
'#If deb = 1 Then
'  On Error GoTo 0
'#Else
'  On Error GoTo lblError
'#End If
'
'
'  Static EllipseJob(1 To 9999) As TEllipseJob
'  Static n As Long
'  Dim l As Long
'  Dim width As Long
'  Dim pen As Long
'  Dim oldPen As Long
'  Dim oldPos As POINTAPI
'  Dim dc As Long
'
'  If Not IsMissing(s) Then
'    If s = 1 Then
'      If sngZoom > 0.1 And n > 0 Then  'bei sehr kleinem Zoom gibt es GPFs beim PlayMetaFile
'
'        dc = lngTmpMetaDC
'
'        width = c.DrawWidth
''        c.FillStyle = 1
'        pen = CreatePen(0, width, vbBlack)
'        oldPen = SelectObject(dc, pen)
'        For l = 1 To n
'          Call dcEllipse(c, EllipseJob(l).x, EllipseJob(l).y, EllipseJob(l).rx, EllipseJob(l).ry)
'        Next l
'        Call SelectObject(dc, oldPen)
'        Call DeleteObject(pen)
'
'      End If
'      n = 0
'    End If
'  ElseIf Not IsMissing(s) Then
'    If s = 2 Then
'      n = 0
'    End If
'  Else
'    If y - ry >= lngYmin And y + ry <= lngYmax Then
'      n = n + 1
'      EllipseJob(n).x = CLng(x + 0.5)
'      EllipseJob(n).y = CLng(y + 0.5)
'      EllipseJob(n).rx = CLng(rx + 0.5)
'      EllipseJob(n).ry = CLng(ry + 0.5)
'    End If
'  End If
'
'AktSub = OldSub
'Exit Sub
'
'lblError:
'  errorbox (Err)
'  Call MausDefault
'  AktSub = OldSub
'
'End Sub
'
Sub SetFont(hDC As Long, fntName As String, fntSiz As Long, fntArc As Single)

Dim arc As Long, lngFontHeight As Long
Static oldFont As Long
Static hFont As Long

If oldFont > 0 Then
  Call SelectObject(hDC, oldFont)
  Call DeleteObject(hFont)
  oldFont = 0
End If

If fntName <> "" Then
  arc = Int(fntArc * 10)
  'virtuelle Fonts erzeugen
'!!
  
  Debug.Print "DPI="; GetDeviceCaps(hDC, LOGPIXELSY)
  
  lngFontHeight = Min1round(fntSiz * 2)
  
  hFont = CreateFont(-lngFontHeight, 0, arc, 0, 0, 0, 0, 0, 1, 4, 16, 2, 4, fntName)
  
  oldFont = SelectObject(hDC, hFont)
End If

End Sub


'liefert den printable area des Printers
Sub getPrinterPA(Hnd As Long, lngL As Long, lngT As Long, lngW As Long, lngH As Long)

  lngL = GetDeviceCaps(Hnd, PHYSICALOFFSETX)
  lngT = GetDeviceCaps(Hnd, PHYSICALOFFSETY)
  lngW = GetDeviceCaps(Hnd, PHYSICALWIDTH) - 2 * lngL
  lngH = GetDeviceCaps(Hnd, PHYSICALHEIGHT) - 2 * lngT

End Sub


Function Min1round(f As Variant) As Long

If f > 0.5 Then
  Min1round = Int(f + 0.5)
Else
  Min1round = 1
End If

End Function

